# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%global namedversion %{version}
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           mojo-animal-sniffer
Version:        1.7
Release:        1%{?dist}
Epoch:          0
Summary:        Tools to assist verifying backward compatibility of Java classes
Group:          Development/Tools
License:        MIT
URL:            http://mojo.codehaus.org/animal-sniffer/
# svn export http://svn.codehaus.org/mojo/tags/animal-sniffer-parent-1.7/ mojo-animal-sniffer-parent-1.7 && tar czf mojo-animal-sniffer-parent-1.7.tgz mojo-animal-sniffer-parent-1.7
Source0:        mojo-animal-sniffer-parent-1.7.tgz
Source1:        animal-sniffer.sh
Patch0:         0001-add-asm-dependency-to-maven-plugin.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       maven2
Requires:       objectweb-asm
Requires:       ant
Requires:       mojo-signatures
Requires:       java
BuildRequires:  java-devel
BuildRequires:  ant
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-invoker
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-shade
BuildRequires:  maven2-plugin-site
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit3
BuildRequires:  mojo-maven2-plugin-build-helper
BuildRequires:  mojo-maven2-plugin-cobertura
BuildRequires:  objectweb-asm
BuildRequires:  plexus-containers-component-javadoc
BuildRequires:  mojo-parent
Provides:       animal-sniffer = %{epoch}:%{version}-%{release}
Obsoletes:      animal-sniffer < %{epoch}:%{version}
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Tools to assist verifying that classes compiled with a newer JDK/API
are compatible with an older JDK/API.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%prep
%setup -q -n %{name}-parent-%{version}
%patch0 -p1 -b .sav0

%build
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
%{_bindir}/mvn-jpp \
         -e \
         -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
         install javadoc:aggregate

%install
rm -rf %{buildroot}

install -d -m 755 %{buildroot}%{_bindir}
install -pm 755 %{SOURCE1} %{buildroot}%{_bindir}/%{name}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}
install -m 644 animal-sniffer-annotations/target/animal-sniffer-annotations-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -m 644 animal-sniffer-ant-tasks/target/animal-sniffer-ant-tasks-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -m 644 animal-sniffer-enforcer-rule/target/animal-sniffer-enforcer-rule-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -m 644 animal-sniffer-maven-plugin/target/animal-sniffer-maven-plugin-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -m 644 animal-sniffer/target/animal-sniffer-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -m 644 java-boot-classpath-detector/target/java-boot-classpath-detector-%{version}.jar %{buildroot}%{_javadir}/%{name}
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
install -m 644 animal-sniffer-annotations/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer-annotations.pom
install -m 644 animal-sniffer-ant-tasks/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer-ant-tasks.pom
install -m 644 animal-sniffer-enforcer-rule/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer-enforcer-rule.pom
install -m 644 animal-sniffer-maven-plugin/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer-maven-plugin.pom
install -m 644 animal-sniffer/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer.pom
install -m 644 java-boot-classpath-detector/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-java-boot-classpath-detector.pom
install -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-animal-sniffer-parent.pom

# depmaps
%add_to_maven_depmap org.codehaus.mojo animal-sniffer %{namedversion} JPP/%{name} animal-sniffer
%add_to_maven_depmap org.codehaus.mojo animal-sniffer-annotations %{namedversion} JPP/%{name} animal-sniffer-annotations
%add_to_maven_depmap org.codehaus.mojo animal-sniffer-ant-tasks %{namedversion} JPP/%{name} animal-sniffer-ant-tasks
%add_to_maven_depmap org.codehaus.mojo animal-sniffer-enforcer-rule %{namedversion} JPP/%{name} animal-sniffer-enforcer-rule
%add_to_maven_depmap org.codehaus.mojo animal-sniffer-maven-plugin %{namedversion} JPP/%{name} animal-sniffer-maven-plugin
%add_to_maven_depmap org.codehaus.mojo animal-sniffer-parent %{namedversion} JPP/%{name} animal-sniffer-parent
%add_to_maven_depmap org.codehaus.mojo java-boot-classpath-detector %{namedversion} JPP/%{name} java-boot-classpath-detector

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%attr(0755,root,root) %{_bindir}/%{name}
%dir %{_javadir}*/%{name}
%exclude %dir %{_javadocdir}/%{name}
%{_javadir}*/%{name}/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/*

%changelog
* Sun Jul 01 2012 Ralph Apel <r.apel@r-apel.de> 0:1.7-1
- 1.7 the JPP style as mojo-animal-sniffer
- Provide and obsolete "animal-sniffer"

* Mon Aug 15 2011 David Walluck <dwalluck@redhat.com> 0:1.6-8.2
- patch some pom versions

* Fri Jun 24 2011 David Walluck <dwalluck@redhat.com> 0:1.6-8.1
- release (based on Fedora release 8)
